<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 77 Pizza365 CRUD</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Admin Page</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/hinhtui.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Huy Nguyen 18+</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="voucher.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="menu.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="drink.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="country.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="region.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="user.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.crud.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order CRUD</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>PIZZA 365</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Orders Manage</h2>
        <div class="row">
        <!--<div class="col-sm-12">
          <button id="btn-clear-data" class="btn btn-danger">Delete All Data</button>
        </div>-->
        </div>
        <div class="jumbotron container">
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="order-code">Mã Đơn hàng</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-order-code" name="order-code" placeholder="order code"
              class="form-control">
            </div>
            </div>
            <div class="row form-group">
            <div class="col-sm-3">
              <label for="pizza-size">Kích Cỡ</label>
            </div>
            <div class="col-sm-9">
              <select type="text" id="select-pizza-size" name="pizza-size" class="form-control">
                <option value="S">Small</option>
                <option value ="M">Medium</option>
                <option value = "L">Large</option>
              </select>
            </div>
            </div>
            
            <div class="row form-group">
            <div class="col-sm-3">
              <label for="pizza-type">Loại Pizza</label>
            </div>
            <div class="col-sm-9">
              <select type="text" id="select-pizza-type" name="pizza-type" class="form-control">
                <option value="hawaii">Hawaii</option>
                <option value="seafood">Seafood</option>
                <option value="bacon">Bacon</option>
              </select>
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-3">
                <label for="voucher-code">Mã Voucher</label>
              </div>
              <div class="col-sm-9">
                <input type="text" id="input-voucher-code" name="pizza-voucher-code" placeholder="voucher code" class="form-control">
              </div>
              </div>
            <div class="row form-group">
            <div class="col-sm-3">
              <label for="price">Thành Tiền</label>
            </div>
            <div class="col-sm-9">
              <input type="number" id="input-price" name="price" placeholder="price" class="form-control">
            </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-3">
                <label for="paid">Phải thanh toán</label>
              </div>
              <div class="col-sm-9">
                <input type="number" id="input-paid" name="paid" placeholder="paid" class="form-control">
              </div>
              </div>
            <div class="row form-group">
            <div class="col-sm-3">
              <label for="createDate">Ngày Tạo</label>
            </div>
            <div class="col-sm-9">
              <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
            </div>
            </div>
            <div class="row form-group">
            <div class="col-sm-3">
              <label for="updateDate">Ngày Cập Nhật</label>
            </div>
            <div class="col-sm-9">
              <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
            </div>
            </div>

          <div class="row form-group">
            <div class="col-sm-3">
              <label for="user">Khách Hàng</label>
            </div>
            <div class="col-sm-9">
              <select type="text" id="select-user" name="user" placeholder="country name"
              class="form-control">
                <option value=0>Chọn khách hàng</option>
              </select>
            </div>
          </div>
          
          <div class="row pull-right">
            <div class="col-sm-3">
            </div>
            <div class="col-sm-9">
              <div class ="row">
                <div class="col-sm-3">
                  <button id="btn-update-order" class="btn btn-info w-100"><i class="fas fa-edit"></i>&nbsp;Update</button>
                </div>
                <div class="col-sm-3">
                  <button id="btn-delete-order" class="btn btn-danger w-100"><i class="fas fa-trash"></i>&nbsp;Delete</button>
                </div>
                <div class="col-sm-3">
                  <button id="btn-create-order" class="btn btn-success w-100"><i class="fa fa-plus"></i>&nbsp;Add New</button>
                </div>
                <div class = "col-sm-3">
                  <button id="btn-cancel" class="btn btn-secondary w-100">Cancel</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>STT</th>
              <th>Mã đơn hàng</th>
              <th>Kích cỡ</th>
              <th>Loại pizza</th>
              <th>Mã voucher</th>
              <th>Thành tiền</th>
              <th>Phải thanh toán</th>
              <th>Ngày tạo</th>
              <th>Ngày cập nhật</th>
            </tr>
        </table>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id order đang đc update or delete. Mặc định = 0;
var gOrderId = 0;
var gUserId = 0;
var gUserArr = [];
const gBASE_URL = "http://localhost:8080/users";
const gCONTENT_TYPE = "application/json;charset=UTF-8";
var gUserSelectElement = $("#select-user");

$(document).ready(function(){
  var table = $("#user-table").DataTable({
    "columns": [
      {"data":"id"},
      {"data":"orderCode"},
      {"data":"pizzaSize"},
      {"data":"pizzaType"},
      {"data":"voucherCode"},
      {"data":"price"},
      {"data":"paid"},
      {"data": "created"},
      {"data": "updated"}
    ]
  })
  loadDataToTable();
  //Get data user
  $.ajax({
    url: gBASE_URL,
    method: "GET",
    success: function(pObjRes) {
      gUserArr = pObjRes;
      console.log(gUserArr);
      loadDataToUserSelect(pObjRes);
    },
    error: function(paramErr) {
      console.log(paramErr.responseText);
    }
  });

		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#user-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update order: add event to save data button
	$("#btn-update-order").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new order
	$("#btn-create-order").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete order selected
	$("#btn-delete-order").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Cancel
	$("#btn-cancel").on("click",function(){
		onCancelBtnClick();
	});
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gOrderId = $(paramRow).find("td:eq(0)").html();
		console.log("Order id of selected row: " + gOrderId);
    gUserId = getUserIdByOrderId(gOrderId);
		//lấy thông tin order của row được click và hiển thị lên form
		var vOrder = callApiGetOrderById(gOrderId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo order obj
		var vOrderObj = {
			orderCode: "",
			pizzaSize: "",
      pizzaType: "",
      voucherCode: "",
      price: 0,
      paid: 0,
      user: -1
		}
		// B1: Thu thập dữ liệu
		getUpdateOrderData(vOrderObj);
		// B2: Validate update
		var vIsOrderValid = validateOrderData(vOrderObj);
    	if (vIsOrderValid){
			// B3: update order
			$.ajax({
				url: gBASE_URL + "/" + gUserId + "/orders/"+ gOrderId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vOrderObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateOrderSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm order
	function onCreateButtonClick(){
		//khai báo order obj
		var vOrderObj = {
			orderCode: "",
			pizzaSize: "",
      pizzaType: "",
      voucherCode: "",
      price: 0,
      paid: 0,
      user: -1
		}
		// B1: Thu thập dữ liệu
		getUpdateOrderData(vOrderObj);
		// B2: Validate data
		var vIsOrderValid = validateOrderData(vOrderObj);
    	if (vIsOrderValid){
			// B3: create order
			$.ajax({
				url: gBASE_URL + "/" + vOrderObj.user + "/orders",
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vOrderObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreateOrderSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa order được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: gBASE_URL +"/" + gUserId + "/orders/"+ gOrderId,
        type: "DELETE",
        success: function(paramRes) {
          handleDeleteOrderSuccess();
        },
        error: function(paramErr) {
          alert("Xóa order không thành công");
        }
      });
	}
  function onCancelBtnClick(){
    $("#input-order-code").val("");
		$("#select-pizza-size").val("");
    $("#select-pizza-type").val(""); 
    $("#input-voucher-code").val("");
    $("#input-price").val("");
    $("#input-createDate").val("");
    $("#input-updateDate").val("");
    $("#select-user").val(0);  
	}
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadDataToTable(){
    $.ajax({
		url: "http://localhost:8080/orders",
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.response);
		}
	})
  };
  //load data to user select
  function loadDataToUserSelect(pUserList) {
    for (let i = 0; i < pUserList.length; i++) {
      var bUserOption = $("<option/>");
      bUserOption.prop("value", pUserList[i].id);
      bUserOption.prop("text", pUserList[i].fullname);
      gUserSelectElement.append(bUserOption);
    };
  }
  //lấy userId theo order Id
  function getUserIdByOrderId(paramId){
    for (let i=0; i<gUserArr.length; i++){
      var vUserOrders = gUserArr[i].orders;
      for (let j=0; j< vUserOrders.length; j++){
        if (paramId == vUserOrders[j].id){
          gUserId = gUserArr[i].id;
          console.log("User id of selected order: " + gUserId);
        }
      }
    }
    return gUserId;
  }
	//hàm gọi API lấy thông tin order của dòng được chọn
	function callApiGetOrderById(paramId){
		$.ajax({
			url: gBASE_URL + "/" + gUserId + "/orders/"+ paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayOrderData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin order của dòng được click
	function displayOrderData(paramOrder){
		$("#input-order-code").val(paramOrder.orderCode);
		$("#select-pizza-size").val(paramOrder.pizzaSize);
    $("#select-pizza-type").val(paramOrder.pizzaType);
    $("#input-voucher-code").val(paramOrder.voucherCode);
    $("#input-price").val(paramOrder.price);
    $("#input-paid").val(paramOrder.paid);
    $("#input-createDate").val(paramOrder.created);
    $("#input-updateDate").val(paramOrder.updated);
    $("#select-user").val(gUserId);
	}
	// hàm thu thập dữ liệu để update order
	function getUpdateOrderData(paramOrderObj) {
		paramOrderObj.orderCode =$("#input-order-code").val().trim();
		paramOrderObj.pizzaSize =$("#select-pizza-size").val();
    paramOrderObj.pizzaType =$("#select-pizza-type").val();
    paramOrderObj.voucherCode =$("#input-voucher-code").val().trim();
    paramOrderObj.price =$("#input-price").val().trim();
    paramOrderObj.paid =$("#input-paid").val().trim();
    paramOrderObj.user =$("#select-user").val();
	}

	// hàm validate data
	function validateOrderData(paramOrderObj) {
		if (paramOrderObj.orderCode === "") {
		alert("Cần nhập mã order");
		return false;
		}
		return true;
	}
	
	//hiển thị cập nhật order thành công
	function handleUpdateOrderSuccess(){
		alert("Sửa order có id: " + gOrderId + " thành công!");
    loadDataToTable();
	};
	//hiển thị thêm order thành công
	function handleCreateOrderSuccess(){
		alert("Thêm order thành công!");
    loadDataToTable();
	};
	//hiển thị cập nhật order thành công
	function handleDeleteOrderSuccess(){
		alert("Xóa order có id: " + gOrderId + " thành công!");
    loadDataToTable();
	};
})
</script>
</body>
</html>
